=== android/app/thirdparty_libs/CMakeLists.txt ===

add_subdirectory(libpng)
add_subdirectory(libjpeg)
add_subdirectory(freetype)
add_subdirectory(harfbuzz)
add_subdirectory(chmlib)
add_subdirectory(antiword)
add_subdirectory(fribidi)
add_subdirectory(libunibreak)
add_subdirectory(qimagescale)
add_subdirectory(zstd)
add_subdirectory(utf8proc)
