=== debian/changelog ===
coolreader3 (3.2.59-1mx25+1) mx; urgency=medium

  * Rebuild for MX 25.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 10 Nov 2025 01:11:59 -0800

coolreader3 (3.2.59-1mx23+1) mx; urgency=medium

  * Import new upstream release.
  * Build against system zstd, unibreak, and fribidi.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 27 Aug 2023 18:27:51 -0700
